<template>
  <div>
    <div class="jeecg-basic-table-form-container" @keyup.enter="searchQuery">
        <a-form :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
          <a-row :gutter="24">
                <a-col :lg="6" >
                    <a-form-item :label="searchFormSchema[0].label">
                        <a-input type="like" placeholder="请输入" v-model:value="queryParam[searchFormSchema[0].field]" />
                    </a-form-item>
                </a-col>
                 <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[1].label">
                        <JInput v-model:value="queryParam[searchFormSchema[1].field]" placeholder="请输入" />
                     </a-form-item>
                 </a-col>
                 <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[2].label">
                        <JInput v-model:value="queryParam[searchFormSchema[2].field]" placeholder="请输入" />
                     </a-form-item>
                 </a-col>
                 <a-col :lg="6">
                    <a-form-item>
                      <a-space :size="5">
                        <a-button type="link" style="padding:0px" @click="expand = !expand">
                            <template v-if="expand">
                              收缩<UpOutlined style="margin-left:0px"/>
                            </template>
                            <template v-else>
                              展开<DownOutlined style="margin-left:0px"/>
                            </template>
                        </a-button>
                        <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery" >查询</a-button>
                        <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset" >重置</a-button>
                      </a-space>
                    </a-form-item>
                  </a-col>
            </a-row>
            <a-row :gutter="24">
              <a-col :lg="6" >
                    <a-form-item :label="searchFormSchema[3].label">
                        <!--<JSearchSelect v-model:value="queryParam[searchFormSchema[3].field]" placeholder="全部" dict="st_domain,domain_name,domain_code" />-->
                        <JTreeSelectDomain  placeholder="请选择" :allowClear="true" 
                            v-model:value="queryParam[searchFormSchema[3].field]" 
                            dict="st_domain,domain_name,domain_code" 
                            pidField="upper_domain_code"
                            pidValue="0"
                            hasChildField="has_child"
                            ></JTreeSelectDomain>
                     </a-form-item>
                </a-col>
                 <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[4].label">
                        <!--<a-input v-model:value="queryParam[searchFormSchema[4].field]" placeholder="请输入" />-->
                        <StSelectLable :value="queryParam.lableCodes" :allowClear="true" @change="updateSelectLable" />
                     </a-form-item>
                 </a-col>
            </a-row>
            <ClassifyCheckbox ref="checkBoxRef" v-show="expand"/>
        </a-form>
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新建</a-button>
          <a-button v-show="showBtn"  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button  v-show="showBtn" type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-if="selectedRowKeys.length > 0 && showBtn">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'caName'">
          <JEllipsisFormat :isLink="true"  :value="record.caName" :length="60" @click="goToCa(record)"/>
        </template>
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
  </div>
    <!-- 表单区域 -->
    <StInnerControlModal @register="registerModal" @success="handleSuccess"></StInnerControlModal>
  </div>
</template>

<script lang="ts" name="standardlib-inner-stInnerControlList" setup>
  import { DownOutlined, UpOutlined } from '@ant-design/icons-vue';
import { onMounted, reactive, ref, toRaw, unref } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { batchDelete, deleteOne, getExportUrl, getImportUrl, list } from './StInnerControl.api';
import { columns, searchFormSchema } from './StInnerControl.data';
import StInnerControlModal from './components/StInnerControlModal.vue';
import { JInput, JTreeSelectDomain, StSelectLable } from '/@/components/Form';
import { useModal } from '/@/components/Modal';
import { BasicTable, TableAction } from '/@/components/Table';
import { useListPage } from '/@/hooks/system/useListPage';
import { downloadFile } from '/@/utils/common/renderUtils';
import ClassifyCheckbox from '/@/views/standardlib/components/ClassifyCheckbox.vue';
import JEllipsisFormat from '/@/views/standardlib/components/JEllipsisFormat.vue';
   const route = useRoute();
 const router = useRouter()
  const expand = ref(false);
  const checkBoxRef = ref(null)
  const checkedKeys = ref<Array<string | number>>([]);
    const showBtn = ref(false)
  //注册model
  const [registerModal, {openModal}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '内控策略表',
           api: list,
           columns,
           canResize:false,
           showTableSetting: false,
           useSearchForm: false,
           actionColumn: {
               width: 160,
               fixed:'right'
            },
            beforeFetch(params) {
              params = Object.assign(params,{ column: 'updatedTime', order: 'desc' })
            },
      },
       exportConfig: {
            name:"内控策略表",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload,setProps},{ rowSelection, selectedRowKeys }] = tableContext
//-----自定义查询----begin--------
const labelCol = reactive({
  xs: {span: 24},
  sm: {span: 8},
})
const wrapperCol = reactive({
    xs: {span: 24},
    sm: {span: 16},
})
const queryParam = reactive({
  lableCodes:''
});
function initParam() {
  const schemas = unref(searchFormSchema);
  schemas.forEach((item) => {
    queryParam[item.field] = ''
  });
  queryParam['checkClassFiy'] = null
  queryParam['lableCodes'] = ''
}
initParam()
function searchQuery(){
  if(expand.value){
      let checkData = checkBoxRef.value?.getCheckValue()
      if(checkData){
        queryParam['checkClassFiy'] = checkData
      }
    }
    setProps({searchInfo:toRaw(queryParam)});
    reload()
}
function searchReset(){
    //Object.assign(queryParam,{ name: '',age_begin: '',age_end: '',sex: '',id: ''});
    initParam()
    checkBoxRef.value?.initQueryParam()
    reload();
}
function goToCa(record){
  if(record.caName=="-"){
    return
  }
  router.push({path: '/standardlib/controlactivity/StCaMainList',query:{bizNo: record.caNo}})
}
onMounted(()=>{
  const bizNo = toRaw(route.query).bizNo
  if(!!bizNo){
  // const queryName = toRaw(route.query).bizNo
  setProps({searchInfo:{strategyNo:bizNo}});
    //reload()
  }
})
function updateSelectLable(val){
  console.log(val)
  queryParam.lableCodes = val
}
   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
       {
           label: '删除',
           color: 'error',
           popConfirm: {
             title: '你确定要删除选中的内控策略吗？',
             confirm: handleDelete.bind(null, record),
           }
         },
         {
           label: '修改',
           onClick: handleEdit.bind(null, record),
         },
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, 
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
        //  {
        //    label: '详情',
        //    onClick: handleDetail.bind(null, record),
        //  }, 
       ]
   }


</script>

<style scoped>

</style>